"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  default: () => src_default
});
module.exports = __toCommonJS(src_exports);
var import_js = __toESM(require("@bugsnag/js"));
var import_fastify_plugin = __toESM(require("fastify-plugin"));
function extractRequestMetadata(request) {
  return {
    body: request.body,
    clientIp: request?.ips?.[0] ?? request.ip,
    headers: request.raw.headers,
    httpMethod: request.routeOptions.method,
    params: request.params,
    path: request.routeOptions.url,
    query: request.query,
    referer: request.raw.headers.referer,
    url: request.url
  };
}
function obtainRequestAndMetadataInfo(request) {
  const metadata = extractRequestMetadata(request);
  return {
    metadata,
    request: {
      clientIp: metadata.clientIp,
      headers: metadata.headers,
      httpMethod: metadata.httpMethod,
      referer: metadata.referer,
      url: metadata.url
    }
  };
}
function bugsnagPlugin(fastify, options, done) {
  import_js.default.start(options);
  fastify.decorate("bugsnag", import_js.default);
  fastify.decorateRequest("bugsnag", null);
  fastify.addHook("onRequest", function decorateRequestInstance(request, reply, next) {
    request.bugsnag = import_js.default;
    next();
  });
  fastify.addHook("onError", async function bugsnagErrorHandlerPlugin(request, reply, error) {
    this.bugsnag.notify(error, (event) => {
      const { metadata, request: requestData } = obtainRequestAndMetadataInfo(request);
      event.request = requestData;
      event.addMetadata("request", metadata);
    });
  });
  done();
}
var src_default = (0, import_fastify_plugin.default)(bugsnagPlugin, {
  fastify: "4.x",
  name: "fastify-bugsnag"
});
//# sourceMappingURL=index.js.map