import { Client, BrowserConfig } from '@bugsnag/js';
import { NodeConfig } from '@bugsnag/node';
import { FastifyRequest } from 'fastify';

type PluginOptions = NodeConfig | BrowserConfig;
interface RequestMetadata {
    body?: FastifyRequest['body'];
    clientIp: string;
    headers: Record<string, any>;
    httpMethod: string;
    params?: unknown;
    path?: string;
    query?: unknown;
    referer?: string;
    url: string;
}
interface RequestInfoWithMetadata {
    metadata: RequestMetadata;
    request: Pick<RequestMetadata, 'clientIp' | 'headers' | 'httpMethod' | 'referer' | 'url'>;
}
declare module 'fastify' {
    interface FastifyInstance {
        bugsnag: Client;
    }
    interface FastifyRequest {
        bugsnag: Client;
    }
}

export type { PluginOptions, RequestInfoWithMetadata, RequestMetadata };
